#ifndef PULSE_DETECTOR_H
#define PULSE_DETECTOR_H

#include "ap_fixed.h"

typedef ap_fixed<18, 2> data_t;
typedef ap_fixed<18, 2> pos_t;
typedef int count_t;
typedef int stat_t;

const stat_t CALIBRATING = 0;
const stat_t BUFFERING = 1;
const stat_t PULSE_OFF = 2;
const stat_t PULSE_ON = 3;

const int F_SIZE = 20;
const int CAL_SIZE = 200;
const data_t THRESHOLD = 0.01;
const data_t ZERO = 0.0;

static bool buffer[F_SIZE];

static data_t average = 0.0;

static stat_t status = CALIBRATING;
static count_t c_counter = 0;
static pos_t p_x = 0.0;
static data_t p_y = 0.0;
static data_t a_p_y = 0.0;

void detect(pos_t sample_x, data_t sample_y, pos_t& out_x, data_t& out_y, int& ok);

#endif
